//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Agent.cpp: implementation of the Agent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <maya/MGlobal.h>
#include "MFCPlugin.h"
#include "Agent.h"
#include "AgentControl.h"
#include "MessageContentTypes.h"
#include "Message.h"
#include "AgentType.h"
#include <iostream>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Agent::Agent(int zoneType /*= 0*/)
{
	finished = false;
	AgentControl::newAgent(this);
	_zoneType = zoneType;
}

Agent::Agent(const Agent& original)
{
	finished = original.finished;
	AgentControl::newAgent(this);
	_zoneType = original._zoneType;
}

Agent::~Agent()
{
	AgentControl::removeAgent(this);
}

double Agent::getImpression(bool& valid) {
	valid = _valid;
	return impression;
}

void	Agent::receiveMessage(Message* theMessage) {
	string contentString;
	stringInt	contentStringInt;


	if (theMessage->getContentType() == "string") {
		contentString = *((string*)theMessage->getContent());

		if (contentString == "placeDown") {
			placeDown();
			return;
		}
	}
	else if(theMessage->getContentType() == "stringInt") {
		contentStringInt = *((stringInt*)theMessage->getContent());

		if (contentStringInt.stringValue == "step") {
			step(contentStringInt.intValue);
			return;
		}
	}

}

string    Agent::getLocalType()
{
	return "";
}

void	Agent::sendMessage(Message* theMessage) {
	AgentControl::relay(theMessage);
}
	
void	Agent::placeDown() {	// This places an agent in a new representation; override if necessary
	finished = false;
	impression = 0;
	_valid = false;
}

void	Agent::loadAnalyses() {
								// Here you'll load all of your analysis pointers by getting them by name from existing representation objects
}								// Access the design by means of AgentControl::getCurrentDesign();


bool	Agent::isOfType(string testType) {
	for (list<string>::iterator i = fullType.begin(); i != fullType.end(); i++)
		if (testType == *i) return true;
	return false;
}

AgentType*	Agent::makeType()
{
	return new AgentType(this);
}

void	Agent::setAgentType(AgentType* myType)
{
	_myType = myType;
}

