//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
#if !defined(AFX_AGENTBOUNDINGBOXDIALOG_H__87E95CD1_63DE_11D4_9FAF_0000E87A7A07__INCLUDED_)
#define AFX_AGENTBOUNDINGBOXDIALOG_H__87E95CD1_63DE_11D4_9FAF_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AgentBoundingBoxDialog.h : header file
//

#include <string>

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// AgentBoundingBoxDialog dialog

class AgentBoundingBoxDialog : public CDialog
{
// Construction
public:
	AgentBoundingBoxDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(AgentBoundingBoxDialog)
	enum { IDD = IDD_AGENT_BOUNDING_BOX };
	BOOL	m_copy_bounding;
	int		m_xweight;
	int		m_yweight;
	int		m_zweight;
	int		m_xcenter;
	int		m_xside;
	int		m_ycenter;
	int		m_yside;
	int		m_zcenter;
	int		m_zside;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(AgentBoundingBoxDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	bool getCopyAcross() {return m_copy_bounding;};
	int  getXside() {return m_xside;};
	int  getXcenter() {return m_xcenter;};
	int  getYside() {return m_yside;};
	int  getYcenter() {return m_ycenter;};
	int  getZside() {return m_zside;};
	int  getZcenter() {return m_zcenter;};
	int  getXWeight() {return m_xweight;};
	int  getYWeight() {return m_yweight;};
	int  getZWeight() {return m_zweight;};

	void setXside(int xside) {m_xside = xside;};
	void setXcenter(int xcenter) {m_xcenter = xcenter;};
	void setYside(int yside) {m_yside = yside;};
	void setYcenter(int ycenter) {m_ycenter = ycenter;};
	void setZside(int zside) {m_zside = zside;};
	void setZcenter(int zcenter) {m_zcenter = zcenter;};
	void setXWeight(int xWeight) {m_xweight = xWeight;};
	void setYWeight(int yWeight) {m_yweight = yWeight;};
	void setZWeight(int zWeight) {m_zweight = zWeight;};
	void setZoneName(const string& zoneName) {_zoneName = zoneName;};
	
	void deleteBoundingBox();

protected:

	void drawBoundingBox();

	string _zoneName;
	// Generated message map functions
	//{{AFX_MSG(AgentBoundingBoxDialog)
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	afx_msg void OnCustomdrawXcenter(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawXside(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawYcenter(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawYside(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawZcenter(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawZside(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AGENTBOUNDINGBOXDIALOG_H__87E95CD1_63DE_11D4_9FAF_0000E87A7A07__INCLUDED_)
