// AgentDesignHeight.h: interface for the AgentDesignHeight class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENTDESIGNHEIGHT_H__BB05E601_4221_11D4_9F8C_0000E87A7A07__INCLUDED_)
#define AFX_AGENTDESIGNHEIGHT_H__BB05E601_4221_11D4_9F8C_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"
#include "AnalysisMaxHeight.h"

const double INITIAL_TARGET_HEIGHT = 10;

class AgentDesignHeight : public Agent  
{
public:
	AgentDesignHeight( int zoneType = 0);
	AgentDesignHeight(const AgentDesignHeight& original);
	virtual ~AgentDesignHeight();

	virtual bool		perZoneType() {return true;};	// This agent type is separated by Zone Type
	virtual bool		hasInterface() {return true;};	// This agent type has an interface
	virtual	int			startingDeployment() {return 1;};	// How many of these to deploy initially
	virtual int			startingWeight() {return 50;};		// What is the starting weight of this agent type?
	virtual bool		step(int stepNum);
	virtual string		getLocalType() {return "AgentDesignHeight";};	// Returns the name of the Agent Type
	virtual Agent*		newOne(int zoneType = 0);
	virtual void		copyProperties(Agent* original);
	virtual void		doInterface();

private:

	virtual void		loadAnalyses();

	double				_targetHeight;

	AnalysisMaxHeight* heightAnalysis;

};

#endif // !defined(AFX_AGENTDESIGNHEIGHT_H__BB05E601_4221_11D4_9F8C_0000E87A7A07__INCLUDED_)
