//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
#if !defined(AFX_AGENTLOCALBOXDIALOG_H__7C13322D_F6BF_11D4_AE3F_00C04FA36E77__INCLUDED_)
#define AFX_AGENTLOCALBOXDIALOG_H__7C13322D_F6BF_11D4_AE3F_00C04FA36E77__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AgentLocalizedBoundingBox.h"
#include <string>
#include <vector>

using namespace std;

// AgentLocalBoxDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// AgentLocalBoxDialog dialog

class AgentLocalBoxDialog : public CDialog
{
// Construction
public:
	AgentLocalBoxDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(AgentLocalBoxDialog)
	enum { IDD = IDD_DIALOG3 };
	BOOL	m_bIntersect;
	int		m_intersectionWeight;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(AgentLocalBoxDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void getIntersectionType(vector<bool>& intersectionTypes);
	void getIntersectionWeight(vector<int>& intersectionWeights);
	
	void setIntersectionType(const vector<bool> intersectionTypes);
	void setIntersectionWeight(const vector<int> intersectionWeights);
	
	void setZoneName(const string& zoneName) {_zoneName = zoneName;};
	void setZoneType(const int zoneType)	{_zoneType = zoneType;};

protected:
	void InitZoneList();
	bool _intersectionType;
	int _zoneSelected;

	string _zoneName;
	int	_zoneType;
	vector<bool>	_IntersectionTypes;
	vector<int>	_intersectionWeights;

	// Generated message map functions
	//{{AFX_MSG(AgentLocalBoxDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeBindingList();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AGENTLOCALBOXDIALOG_H__7C13322D_F6BF_11D4_AE3F_00C04FA36E77__INCLUDED_)
