//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentOverallDesignHeight.h: interface for the AgentOverallDesignHeight class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENTOVERALLDESIGNHEIGHT_H__F851DFCD_EAF2_11D4_AE3D_00C04FA36E77__INCLUDED_)
#define AFX_AGENTOVERALLDESIGNHEIGHT_H__F851DFCD_EAF2_11D4_AE3D_00C04FA36E77__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"
#include "AnalysisOverallDesignHeight.h"

const double HEIGHT_DESIRED = 50.0;

class AgentOverallDesignHeight : public Agent
{
public:
	AgentOverallDesignHeight();
	virtual ~AgentOverallDesignHeight();

	virtual bool		perZoneType() {return false;};	// This agent type is not separated by Zone Type
	virtual bool		hasInterface() {return true;};	// This agent type has an interface
	virtual	int			startingDeployment() {return 1;};	// How many of these to deploy initially
	virtual int			startingWeight() {return 50;};		// What is the starting weight of this agent type?
	virtual bool		step(int stepNum);
	virtual string		getLocalType() {return "AgentOverallDesignHeight";};	// Returns the name of the Agent Type
	virtual Agent*		newOne(int zoneType = 0);
	virtual void		copyProperties(Agent* original);
	virtual void		doInterface();
	virtual void		reportSettings();		// Add settings to Settings		NOTE: Agents are not Settables!
	virtual void		receiveSettings();		// Get settings from Settings		NOTE: Agents are not Settables!

private:

	virtual void		loadAnalyses();

	double					_desiredHeight;

	AnalysisOverallDesignHeight* heightAnalysis;

};

#endif // !defined(AFX_AGENTOVERALLDESIGNHEIGHT_H__F851DFCD_EAF2_11D4_AE3D_00C04FA36E77__INCLUDED_)
