//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentShapeSize.h: interface for the AgentShapeSize class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENTSHAPESIZE_H__5CA1E39A_667E_11D4_9FB1_0000E87A7A07__INCLUDED_)
#define AFX_AGENTSHAPESIZE_H__5CA1E39A_667E_11D4_9FB1_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"
#include "AnalysisShapeSize.h"

const double SS_MIN_X = 1;
const double SS_MIN_Y = 1;
const double SS_MIN_Z = 1;
const double SS_MAX_X = 20;
const double SS_MAX_Y = 20;
const double SS_MAX_Z = 20;

const int SS_XWEIGHT = 50;
const int SS_YWEIGHT = 50;
const int SS_ZWEIGHT = 50;

class AgentShapeSize : public Agent  
{
public:
	AgentShapeSize(int zoneType = 0);
	virtual ~AgentShapeSize();

	virtual bool		perZoneType() {return true;};	// This agent type is separated by Zone Type
	virtual bool		hasInterface() {return true;};	// This agent type has an interface
	virtual	int			startingDeployment() {return 1;};	// How many of these to deploy initially
	virtual int			startingWeight() {return 50;};		// What is the starting weight of this agent type?
	virtual bool		step(int stepNum);
	virtual string		getLocalType() {return "AgentShapeSize";};	// Returns the name of the Agent Type
	virtual Agent*		newOne(int zoneType = 0);
	virtual void		copyProperties(Agent* original);
	virtual void		doInterface();
	virtual void		reportSettings();		// Add settings to Settings		NOTE: Agents are not Settables!
	virtual void		receiveSettings();		// Get settings from Settings		NOTE: Agents are not Settables!

private:

	virtual void		loadAnalyses();

	double				_minX;
	double				_minY;
	double				_minZ;
	double				_maxX;
	double				_maxY;
	double				_maxZ;

	int					_XWeight;
	int					_YWeight;
	int					_ZWeight;

	AnalysisShapeSize* sizeAnalysis;
};

#endif // !defined(AFX_AGENTSHAPESIZE_H__5CA1E39A_667E_11D4_9FB1_0000E87A7A07__INCLUDED_)
