//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AgentShapeSizeDialog.cpp : implementation file
//

#include "stdafx.h"
#include "MFCPlugin.h"
#include "AgentShapeSizeDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AgentShapeSizeDialog dialog


AgentShapeSizeDialog::AgentShapeSizeDialog(CWnd* pParent /*=NULL*/)
	: CDialog(AgentShapeSizeDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(AgentShapeSizeDialog)
	m_copyAcross = FALSE;
	m_xmax = 0;
	m_xmin = 0;
	m_xweight = 0;
	m_ymax = 0;
	m_ymin = 0;
	m_yweight = 0;
	m_zmax = 0;
	m_zmin = 0;
	m_zweight = 0;
	//}}AFX_DATA_INIT
}


void AgentShapeSizeDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(AgentShapeSizeDialog)
	DDX_Check(pDX, IDC_COPY_SHAPE_SIZE_PROPS_ACROSS_ZONETYPES, m_copyAcross);
	DDX_Text(pDX, IDC_SHAPE_SIZE_XMAX, m_xmax);
	DDV_MinMaxInt(pDX, m_xmax, 0, 1000);
	DDX_Text(pDX, IDC_SHAPE_SIZE_XMIN, m_xmin);
	DDV_MinMaxInt(pDX, m_xmin, 0, 1000);
	DDX_Text(pDX, IDC_SHAPE_SIZE_XWEIGHT, m_xweight);
	DDV_MinMaxInt(pDX, m_xweight, 0, 100);
	DDX_Text(pDX, IDC_SHAPE_SIZE_YMAX, m_ymax);
	DDV_MinMaxInt(pDX, m_ymax, 0, 1000);
	DDX_Text(pDX, IDC_SHAPE_SIZE_YMIN, m_ymin);
	DDV_MinMaxInt(pDX, m_ymin, 0, 1000);
	DDX_Text(pDX, IDC_SHAPE_SIZE_YWEIGHT, m_yweight);
	DDV_MinMaxInt(pDX, m_yweight, 0, 100);
	DDX_Text(pDX, IDC_SHAPE_SIZE_ZMAX, m_zmax);
	DDV_MinMaxInt(pDX, m_zmax, 0, 1000);
	DDX_Text(pDX, IDC_SHAPE_SIZE_ZMIN, m_zmin);
	DDV_MinMaxInt(pDX, m_zmin, 0, 1000);
	DDX_Text(pDX, IDC_SHAPE_SIZE_ZWEIGHT, m_zweight);
	DDV_MinMaxInt(pDX, m_zweight, 0, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AgentShapeSizeDialog, CDialog)
	//{{AFX_MSG_MAP(AgentShapeSizeDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AgentShapeSizeDialog message handlers

BOOL AgentShapeSizeDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	((CStatic*)GetDlgItem(IDC_SS_SETTINGS_FOR_ZONE_TYPE))->SetWindowText(("Shape size settings for ZoneType: " + _zoneName).c_str());
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
