//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AnalysisCountShapes.cpp: implementation of the AnalysisCountShapes class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <maya/MGlobal.h>
#include "MFCPlugin.h"
#include "AnalysisCountShapes.h"
#include "Design.h"
#include "AgentControl.h"
#include "Shape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AnalysisCountShapes::AnalysisCountShapes()
{

}

AnalysisCountShapes::~AnalysisCountShapes()
{

}

void AnalysisCountShapes::getCount(int& count, int& total, int zoneType)
{
	Design*	theDesign = AgentControl::getCurrentDesign();
	Phenotype*	thePhenome = &(theDesign->getPhenome());
	Shape*		currentShape;

	count = 0;
	total = 0;

	for (list<Shape*>::iterator i = thePhenome->getShapes().begin(); i != thePhenome->getShapes().end(); i++) {
		total++;
		if (zoneType == (*i)->getPEType().getType()) count++;
	}
}