//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AnalysisLocalizedBoundingBox.h: interface for the AnalysisLocalizedBoundingBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANALYSISLOCALIZEDBOUNDINGBOX_H__A3134493_F137_11D4_AE3E_00C04FA36E77__INCLUDED_)
#define AFX_ANALYSISLOCALIZEDBOUNDINGBOX_H__A3134493_F137_11D4_AE3E_00C04FA36E77__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Analysis.h"
#include <vector>
#include "Shape.h"


using namespace std;

typedef enum { INSIDE, PARTIALLY, OUTSIDE } BoundaryRelation;
typedef enum {NONE, BINDING, BOUNCING} BindingType;

class AnalysisLocalizedBoundingBox : public Analysis
{
public:
	AnalysisLocalizedBoundingBox();
	virtual ~AnalysisLocalizedBoundingBox();

	void getBoundaryRelations(vector<int>& numberOfIntersections, vector<int>& numberOfSurfaces, int zoneType);
	//void getBoundaryRelations(vector<BoundaryRelation>& bounds, vector<int>& zoneOfOtherCurve, const vector<BindingType>& bindingTypes, int zoneType = -1);

protected:
	BoundaryRelation FindIntersection(Shape* Boundary, Shape* Other);
};

#endif // !defined(AFX_ANALYSISLOCALIZEDBOUNDINGBOX_H__A3134493_F137_11D4_AE3E_00C04FA36E77__INCLUDED_)
