//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AnalysisOverallDesignHeight.cpp: implementation of the AnalysisOverallDesignHeight class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <maya/MGlobal.h>
#include "MFCPlugin.h"
#include "AnalysisOverallDesignHeight.h"
#include "Design.h"
#include "AgentControl.h"
#include "Shape.h"
#include "MELUtilities.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AnalysisOverallDesignHeight::AnalysisOverallDesignHeight()
{
	name = "AnalysisOverallDesignHeight";
}

AnalysisOverallDesignHeight::~AnalysisOverallDesignHeight()
{

}

void AnalysisOverallDesignHeight::getDesignHeight(double &minZ, double &maxZ, double &diff)
{
	Design*	theDesign = AgentControl::getCurrentDesign();
	Phenotype*	thePhenome = &(theDesign->getPhenome());
	Shape*		currentShape;
	double tempMinZ, tempMaxZ;

	minZ = 10000;
	maxZ = -10000;

	
	for (list<Shape*>::iterator i = thePhenome->getShapes().begin(); i != thePhenome->getShapes().end(); i++) {
		eval("float $minZ = `getAttr \"" + (*i)->getLoftName() + ".bbny\"`");
		eval("float $maxZ = `getAttr \"" + (*i)->getLoftName() + ".bbxy\"`");
		getMELvalue("$minZ", tempMinZ);
		getMELvalue("$maxZ", tempMaxZ);

		if (tempMinZ < minZ) minZ = tempMinZ;
		if (tempMaxZ > maxZ) maxZ = tempMaxZ;
	}
	diff = maxZ - minZ;
}
