//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// AnalysisShapeSize.cpp: implementation of the AnalysisShapeSize class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <maya/MGlobal.h>
#include "MFCPlugin.h"
#include "AnalysisShapeSize.h"
#include "Design.h"
#include "AgentControl.h"
#include "Shape.h"
#include "MELUtilities.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AnalysisShapeSize::AnalysisShapeSize()
{
	name = "AnalysisShapeSize";
}

AnalysisShapeSize::~AnalysisShapeSize()
{

}

void AnalysisShapeSize::getSize(bool& any, double& minX, double& minY, double& minZ,
											   double& maxX, double& maxY, double& maxZ,
											   int zoneType /*= -1*/)
{
	Design*	theDesign = AgentControl::getCurrentDesign();
	Phenotype*	thePhenome = &(theDesign->getPhenome());
	Shape*		currentShape;
	double tempX, tempY, tempZ;

	minX = 10000;
	minY = 10000;
	minZ = 10000;
	maxX = -10000;
	maxY = -10000;
	maxZ = -10000;

	any = false;

	for (list<Shape*>::iterator i = thePhenome->getShapes().begin(); i != thePhenome->getShapes().end(); i++) {
		if ((zoneType == -1) || (zoneType == (*i)->getPEType().getType())) {
			any = true;
			eval("float $sizeX = `getAttr \"" + (*i)->getLoftName() + ".bbsx\"`");
			eval("float $sizeY = `getAttr \"" + (*i)->getLoftName() + ".bbsz\"`");
			eval("float $sizeZ = `getAttr \"" + (*i)->getLoftName() + ".bbsy\"`");
			getMELvalue("$sizeX", tempX);
			getMELvalue("$sizeY", tempY);
			getMELvalue("$sizeZ", tempZ);

			if (tempX < minX) minX = tempX;
			if (tempY < minY) minY = tempY;
			if (tempZ < minZ) minZ = tempZ;
			if (tempX > maxX) maxX = tempX;
			if (tempY > maxY) maxY = tempY;
			if (tempZ > maxZ) maxZ = tempZ;
		}
	}
}
