//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Command.h: interface for the Command class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OMMAND_H__B350BBA0_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
#define AFX_OMMAND_H__B350BBA0_E931_11D3_9F59_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>

class PrimaryShape;

typedef	enum {COMMAND_OPENING, COMMAND_REFLECT, COMMAND_TRANSLATE, COMMAND_SCALE, COMMAND_ROTATE} CommandType;

class Command  
{
public:
	Command();
	Command(const Command& oldCommand);
	virtual ~Command();

	virtual CommandType type() const = 0;   // Identify what kind of command you are

	virtual std::string print() const = 0;  // Output what the command is for trace purposes
	
	virtual Command* clone() const = 0; //Due to a STUPID bug in VC++, all overloaded functions in derived classes must be of return type Command&.  
										//The c++ spec specifies that they should be allowed to be of return type T& where T is a class derived from Command 
	virtual void mutate() = 0; //mutate the parameters of the command

	virtual void randomize() = 0; // set all parameters to random values including PERing if it exists

	virtual void randomizePERing() = 0; // randomize PERing if it exists, if not do nothing

	virtual void run(PrimaryShape* theShape) = 0; // Execute this command

};

#endif // !defined(AFX_OMMAND_H__B350BBA0_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
