//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// EmergentShape.cpp: implementation of the EmergentShape class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <maya/MGlobal.h>
#include "EmergentShape.h"
#include "MayaUtilities.h"
#include <iostream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EmergentShape::EmergentShape()
: Shape()
{

}

EmergentShape::EmergentShape(const Shape& oldShape)
: Shape(oldShape)
{
}

EmergentShape::~EmergentShape()
{

}

Shape*	EmergentShape::fullDuplicate()
{
	EmergentShape* newShape = new EmergentShape(*this);
	string newName;
	if (duplicateCurve(mayaShape, newName))	{	// Make a copy of the original curve for this to refer to
		mayaShape->setName(newName);
		cleanupList.push_back(newName);
	}
	return newShape;
}
