//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Filter.cpp: implementation of the Filter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MFCPlugin.h"
#include "Filter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Filter::Filter()
{
	clear();
	mode = FILTER_ON;
}

Filter::~Filter()
{

}

void	Filter::addAgent(AgentID theAgent) {
	agents.push_back(theAgent);
}

void Filter::addAgentType(const string& theType) {
	agentTypes.push_back(theType);
}

void	Filter::clear() {
	agents.clear();
	agentTypes.clear();
}


bool Filter::matches(AgentID theAgent) {
	if (mode == FILTER_ALL) return true;
	if (mode == FILTER_CONTROL) return false;
	if (mode == FILTER_ON) {
		for (list<string>::iterator i = agentTypes.begin(); i != agentTypes.end(); i++)
			if (theAgent->isOfType(*i)) return true;
		for (list<AgentID>::iterator j = agents.begin(); j != agents.end(); j++)
			if (theAgent == *j) return true;
	}
}