//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Filter.h: interface for the Filter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILTER_H__35068A32_3E41_11D4_9F88_0000E87A7A07__INCLUDED_)
#define AFX_FILTER_H__35068A32_3E41_11D4_9F88_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Agent.h"
#include <list>

typedef enum {FILTER_ALL, FILTER_CONTROL, FILTER_ON} FilterMode;

using namespace std;

class Filter  
{
public:
	Filter();
	virtual ~Filter();

	void clear();
	void addAgentType(const string& theType);
	void addAgent(AgentID theAgent);

	bool matches(AgentID theAgent); // Does this filter select this agentID
	bool matches(string theType); // Does this filter select this agent type

	void FilterAll()		{mode = FILTER_ALL;};				// Send message to all agents
	void FilterControl()	{mode = FILTER_CONTROL;};		// Send message only to the control center
	void FilterOn()			{mode = FILTER_ON;};			// Filter message by agentIDs and agentTypes listed

private:

	FilterMode	mode;

	list<AgentID> agents;
	list<string> agentTypes;
};

#endif // !defined(AFX_FILTER_H__35068A32_3E41_11D4_9F88_0000E87A7A07__INCLUDED_)
