//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// GeneticEngineProperties.cpp : implementation file
//

#include "stdafx.h"
#include "MFCPlugin.h"
#include "GeneticEngineProperties.h"
#include <iostream>
#include "DialogUtilities.h"
#include "PopulationProperties.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GeneticEngineProperties property page

IMPLEMENT_DYNCREATE(GeneticEngineProperties, CPropertyPage)

GeneticEngineProperties::GeneticEngineProperties() : CPropertyPage(GeneticEngineProperties::IDD)
{
	//{{AFX_DATA_INIT(GeneticEngineProperties)
	m_shapeParameterEdit = 0;
	m_endInsertEdit = 0;
	m_commandChangeEdit = 0;
	m_commandDeleteEdit = 0;
	m_commandInsertEdit = 0;
	m_commandParametersEdit = 0;
	m_copiesOfElitesEdit = 0;
	m_crossoverEdit = 0;
	m_elitesEdit = 0;
	m_fullyRandomizeEdit = 0;
	m_middleInsertEdit = 0;
	m_programTypeEdit = 0;
	m_shapeModeEdit = 0;
	m_tournamentSizeEdit = 0;
	m_wideningEdit = 0;
	m_ZHeightEdit = 0;
	m_ZStartEdit = 0;
	m_shapeParameterSlider = 0;
	m_commandChangeSlider = 0;
	m_commandDeleteSlider = 0;
	m_commandInsertionSlider = 0;
	m_commandParametersSlider = 0;
	m_crossoverSlider = 0;
	m_endInsertionSlider = 0;
	m_fullyRandomizeSlider = 0;
	m_middleInsertionSlider = 0;
	m_populationSizeEdit = 0;
	m_programTypeSlider = 0;
	m_shapeModeSlider = 0;
	m_wideningSlider = 0;
	m_ZHeightSlider = 0;
	m_ZStartSlider = 0;
	//}}AFX_DATA_INIT

	theEngine = NULL;
}

GeneticEngineProperties::~GeneticEngineProperties()
{
}

void GeneticEngineProperties::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(GeneticEngineProperties)
	DDX_Text(pDX, IDC_SHAPE_PARAMETER_EDIT, m_shapeParameterEdit);
	DDV_MinMaxInt(pDX, m_shapeParameterEdit, 0, 100);
	DDX_Text(pDX, IDC_END_INSERT_EDIT, m_endInsertEdit);
	DDV_MinMaxInt(pDX, m_endInsertEdit, 0, 100);
	DDX_Text(pDX, IDC_COMMAND_CHANGE_EDIT, m_commandChangeEdit);
	DDV_MinMaxInt(pDX, m_commandChangeEdit, 0, 100);
	DDX_Text(pDX, IDC_COMMAND_DELETE_EDIT, m_commandDeleteEdit);
	DDV_MinMaxInt(pDX, m_commandDeleteEdit, 0, 100);
	DDX_Text(pDX, IDC_COMMAND_INSERT_EDIT, m_commandInsertEdit);
	DDV_MinMaxInt(pDX, m_commandInsertEdit, 0, 100);
	DDX_Text(pDX, IDC_COMMAND_PARAMETERS_EDIT, m_commandParametersEdit);
	DDV_MinMaxInt(pDX, m_commandParametersEdit, 0, 100);
	DDX_Text(pDX, IDC_COPIES_OF_ELITES_EDIT, m_copiesOfElitesEdit);
	DDX_Text(pDX, IDC_CROSSOVER_EDIT, m_crossoverEdit);
	DDV_MinMaxInt(pDX, m_crossoverEdit, 0, 100);
	DDX_Text(pDX, IDC_ELITES_EDIT, m_elitesEdit);
	DDV_MinMaxInt(pDX, m_elitesEdit, 0, 100);
	DDX_Text(pDX, IDC_FULLY_RANDOMIZE_EDIT, m_fullyRandomizeEdit);
	DDV_MinMaxInt(pDX, m_fullyRandomizeEdit, 0, 100);
	DDX_Text(pDX, IDC_MIDDLE_INSERT_EDIT, m_middleInsertEdit);
	DDV_MinMaxInt(pDX, m_middleInsertEdit, 0, 100);
	DDX_Text(pDX, IDC_PROGRAM_TYPE_EDIT, m_programTypeEdit);
	DDV_MinMaxInt(pDX, m_programTypeEdit, 0, 100);
	DDX_Text(pDX, IDC_SHAPE_MODE_EDIT, m_shapeModeEdit);
	DDV_MinMaxInt(pDX, m_shapeModeEdit, 0, 100);
	DDX_Text(pDX, IDC_TOURNAMENT_SIZE_EDIT, m_tournamentSizeEdit);
	DDV_MinMaxInt(pDX, m_tournamentSizeEdit, 0, 100);
	DDX_Text(pDX, IDC_WIDENING_EDIT, m_wideningEdit);
	DDV_MinMaxInt(pDX, m_wideningEdit, 0, 100);
	DDX_Text(pDX, IDC_Z_HEIGHT_EDIT, m_ZHeightEdit);
	DDV_MinMaxInt(pDX, m_ZHeightEdit, 0, 100);
	DDX_Text(pDX, IDC_Z_START_EDIT, m_ZStartEdit);
	DDV_MinMaxInt(pDX, m_ZStartEdit, 0, 100);
	DDX_Slider(pDX, IDC_SHAPE_PARAMETER_SLIDER, m_shapeParameterSlider);
	DDX_Slider(pDX, IDC_COMMAND_CHANGE_SLIDER, m_commandChangeSlider);
	DDX_Slider(pDX, IDC_COMMAND_DELETE_SLIDER, m_commandDeleteSlider);
	DDX_Slider(pDX, IDC_COMMAND_INSERTION_SLIDER, m_commandInsertionSlider);
	DDX_Slider(pDX, IDC_COMMAND_PARAMETERS_SLIDER, m_commandParametersSlider);
	DDX_Slider(pDX, IDC_CROSSOVER_SLIDER, m_crossoverSlider);
	DDX_Slider(pDX, IDC_END_INSERTION_SLIDER, m_endInsertionSlider);
	DDX_Slider(pDX, IDC_FULLY_RANDOMIZE_SLIDER, m_fullyRandomizeSlider);
	DDX_Slider(pDX, IDC_MIDDLE_INSERTION_SLIDER, m_middleInsertionSlider);
	DDX_Text(pDX, IDC_POPULATION_SIZE, m_populationSizeEdit);
	DDV_MinMaxInt(pDX, m_populationSizeEdit, 1, 1000);
	DDX_Slider(pDX, IDC_PROGRAM_TYPE_SLIDER, m_programTypeSlider);
	DDX_Slider(pDX, IDC_SHAPE_MODE_SLIDER, m_shapeModeSlider);
	DDX_Slider(pDX, IDC_WIDENING_SLIDER, m_wideningSlider);
	DDX_Slider(pDX, IDC_Z_HEIGHT_SLIDER, m_ZHeightSlider);
	DDX_Slider(pDX, IDC_Z_START_SLIDER, m_ZStartSlider);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(GeneticEngineProperties, CPropertyPage)
	//{{AFX_MSG_MAP(GeneticEngineProperties)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_SHAPE_PARAMETER_EDIT, OnChangeShapeParameterEdit)
	ON_EN_CHANGE(IDC_COMMAND_CHANGE_EDIT, OnChangeCommandChangeEdit)
	ON_EN_CHANGE(IDC_COMMAND_DELETE_EDIT, OnChangeCommandDeleteEdit)
	ON_EN_CHANGE(IDC_COMMAND_INSERT_EDIT, OnChangeCommandInsertEdit)
	ON_EN_CHANGE(IDC_COMMAND_PARAMETERS_EDIT, OnChangeCommandParametersEdit)
	ON_EN_CHANGE(IDC_CROSSOVER_EDIT, OnChangeCrossoverEdit)
	ON_EN_CHANGE(IDC_END_INSERT_EDIT, OnChangeEndInsertEdit)
	ON_EN_CHANGE(IDC_FULLY_RANDOMIZE_EDIT, OnChangeFullyRandomizeEdit)
	ON_EN_CHANGE(IDC_MIDDLE_INSERT_EDIT, OnChangeMiddleInsertEdit)
	ON_EN_CHANGE(IDC_PROGRAM_TYPE_EDIT, OnChangeProgramTypeEdit)
	ON_EN_CHANGE(IDC_SHAPE_MODE_EDIT, OnChangeShapeModeEdit)
	ON_EN_CHANGE(IDC_WIDENING_EDIT, OnChangeWideningEdit)
	ON_EN_CHANGE(IDC_Z_HEIGHT_EDIT, OnChangeZHeightEdit)
	ON_EN_CHANGE(IDC_Z_START_EDIT, OnChangeZStartEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GeneticEngineProperties message handlers


void GeneticEngineProperties::setEngine(GeneticEngine* newEngine) {
	theEngine = newEngine;
}

void GeneticEngineProperties::refreshValues()
{
	m_copiesOfElitesEdit = theEngine->getEliteCopies();
	m_elitesEdit = theEngine->getElitism();
	m_tournamentSizeEdit = theEngine->getTournamentSize();
	m_populationSizeEdit = theEngine->getPopulationSize();

	((CSliderCtrl*)GetDlgItem(IDC_SHAPE_PARAMETER_SLIDER))->SetRange( 0, 100);
	m_shapeParameterEdit = theEngine->getParamMutationPercent();
	m_shapeParameterSlider = m_shapeParameterEdit;

	((CSliderCtrl*)GetDlgItem(IDC_END_INSERTION_SLIDER))->SetRange( 0, 100);
	m_endInsertEdit = theEngine->getEndPercent();
	m_endInsertionSlider = m_endInsertEdit;

	((CSliderCtrl*)GetDlgItem(IDC_COMMAND_CHANGE_SLIDER))->SetRange( 0, 100);
	m_commandChangeEdit = theEngine->getChangeMutationPercent();
	m_commandChangeSlider = m_commandChangeEdit;

	((CSliderCtrl*)GetDlgItem(IDC_COMMAND_DELETE_SLIDER))->SetRange( 0, 100);
	m_commandDeleteEdit = theEngine->getDeletePercent();
	m_commandDeleteSlider = m_commandDeleteEdit;

	((CSliderCtrl*)GetDlgItem(IDC_COMMAND_INSERTION_SLIDER))->SetRange( 0, 100);
	m_commandInsertEdit = theEngine->getInsertionMutationPercent();
	m_commandInsertionSlider = m_commandInsertEdit;

	((CSliderCtrl*)GetDlgItem(IDC_COMMAND_PARAMETERS_SLIDER))->SetRange( 0, 100);
	m_commandParametersEdit = theEngine->getParamPercent();
	m_commandParametersSlider = m_commandParametersEdit;

	((CSliderCtrl*)GetDlgItem(IDC_CROSSOVER_SLIDER))->SetRange( 0, 100);
	m_crossoverEdit = theEngine->getCrossoverPercent();
	m_crossoverSlider = m_crossoverEdit;

	((CSliderCtrl*)GetDlgItem(IDC_FULLY_RANDOMIZE_SLIDER))->SetRange( 0, 100);
	m_fullyRandomizeEdit = theEngine->getCompletePercent();
	m_fullyRandomizeSlider = m_fullyRandomizeEdit;

	((CSliderCtrl*)GetDlgItem(IDC_MIDDLE_INSERTION_SLIDER))->SetRange( 0, 100);
	m_middleInsertEdit = theEngine->getMiddlePercent();
	m_middleInsertionSlider = m_middleInsertEdit;

	((CSliderCtrl*)GetDlgItem(IDC_PROGRAM_TYPE_SLIDER))->SetRange( 0, 100);
	m_programTypeEdit = theEngine->getPETypePercent();
	m_programTypeSlider = m_programTypeEdit;

	((CSliderCtrl*)GetDlgItem(IDC_SHAPE_MODE_SLIDER))->SetRange( 0, 100);
	m_shapeModeEdit = theEngine->getShapeModePercent();
	m_shapeModeSlider = m_shapeModeEdit;

/*	((CSliderCtrl*)GetDlgItem(IDC_TYPE_RING_SLIDER))->SetRange( 0, 100);
	m_typeRingEdit = theEngine->getRingPercent();
	m_typeRingSlider = m_typeRingEdit;
*/
	((CSliderCtrl*)GetDlgItem(IDC_WIDENING_SLIDER))->SetRange( 0, 100);
	m_wideningEdit = theEngine->getZWideningPercent();
	m_wideningSlider = m_wideningEdit;

	((CSliderCtrl*)GetDlgItem(IDC_Z_HEIGHT_SLIDER))->SetRange( 0, 100);
	m_ZHeightEdit = theEngine->getZHeightPercent();
	m_ZHeightSlider = m_ZHeightEdit;

	((CSliderCtrl*)GetDlgItem(IDC_Z_START_SLIDER))->SetRange( 0, 100);
	m_ZStartEdit = theEngine->getZStartPercent();
	m_ZStartSlider = m_ZStartEdit;
}

BOOL GeneticEngineProperties::OnInitDialog() 
{

	refreshValues();

	CPropertyPage::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void GeneticEngineProperties::recalculate() {
}

void GeneticEngineProperties::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	
	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
	
	int ctrlID = pScrollBar->GetDlgCtrlID();

	switch (ctrlID) {
	case IDC_SHAPE_PARAMETER_SLIDER:
		sliderChanged(this, ctrlID, IDC_SHAPE_PARAMETER_EDIT, m_shapeParameterSlider, m_shapeParameterEdit);
		break;
	case IDC_PROGRAM_TYPE_SLIDER:
		sliderChanged(this, ctrlID, IDC_PROGRAM_TYPE_EDIT, m_programTypeSlider, m_programTypeEdit);
		break;
	case IDC_SHAPE_MODE_SLIDER:
		sliderChanged(this, ctrlID, IDC_SHAPE_MODE_EDIT, m_shapeModeSlider, m_shapeModeEdit);
		break;
	case IDC_WIDENING_SLIDER:
		sliderChanged(this, ctrlID, IDC_WIDENING_EDIT, m_wideningSlider, m_wideningEdit);
		break;
	case IDC_Z_HEIGHT_SLIDER:
		sliderChanged(this, ctrlID, IDC_Z_HEIGHT_EDIT, m_ZHeightSlider, m_ZHeightEdit);
		break;
	case IDC_COMMAND_INSERTION_SLIDER:
		sliderChanged(this, ctrlID, IDC_COMMAND_INSERT_EDIT, m_middleInsertionSlider, m_middleInsertEdit);
		break;
	case IDC_Z_START_SLIDER:
		sliderChanged(this, ctrlID, IDC_Z_START_EDIT, m_ZStartSlider, m_ZStartEdit);
		break;
	case IDC_MIDDLE_INSERTION_SLIDER:
		sliderChanged(this, ctrlID, IDC_MIDDLE_INSERT_EDIT, m_shapeParameterSlider, m_shapeParameterEdit);
		break;
	case IDC_END_INSERTION_SLIDER:
		sliderChanged(this, ctrlID, IDC_END_INSERT_EDIT, m_endInsertionSlider, m_endInsertEdit);
		break;
	case IDC_COMMAND_CHANGE_SLIDER:
		sliderChanged(this, ctrlID, IDC_COMMAND_CHANGE_EDIT, m_commandChangeSlider, m_commandChangeEdit);
		break;
//	case IDC_TYPE_RING_SLIDER:
//		sliderChanged(this, ctrlID, IDC_TYPE_RING_EDIT, m_typeRingSlider, m_typeRingEdit);
//		break;
	case IDC_FULLY_RANDOMIZE_SLIDER:
		sliderChanged(this, ctrlID, IDC_FULLY_RANDOMIZE_EDIT, m_fullyRandomizeSlider, m_fullyRandomizeEdit);
		break;
	case IDC_COMMAND_DELETE_SLIDER:
		sliderChanged(this, ctrlID, IDC_COMMAND_DELETE_EDIT, m_commandDeleteSlider, m_commandDeleteEdit);
		break;
	case IDC_CROSSOVER_SLIDER:
		sliderChanged(this, ctrlID, IDC_CROSSOVER_EDIT, m_crossoverSlider, m_crossoverEdit);
		break;
	case IDC_COMMAND_PARAMETERS_SLIDER:
		sliderChanged(this, ctrlID, IDC_COMMAND_PARAMETERS_EDIT, m_commandParametersSlider, m_commandParametersEdit);
		break;
	}

	recalculate();
}

void GeneticEngineProperties::OnChangeShapeParameterEdit() 
{
	editChanged(this, IDC_SHAPE_PARAMETER_SLIDER, IDC_SHAPE_PARAMETER_EDIT, m_shapeParameterSlider, m_shapeParameterEdit, 0, 100);
	recalculate();
}

void GeneticEngineProperties::OnChangeCommandChangeEdit() 
{
	editChanged(this, IDC_COMMAND_CHANGE_SLIDER, IDC_COMMAND_CHANGE_EDIT, m_commandChangeSlider, m_commandChangeEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeCommandDeleteEdit() 
{
	editChanged(this, IDC_COMMAND_DELETE_SLIDER, IDC_COMMAND_DELETE_EDIT, m_commandDeleteSlider, m_commandDeleteEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeCommandInsertEdit() 
{
	editChanged(this, IDC_COMMAND_INSERTION_SLIDER, IDC_COMMAND_INSERT_EDIT, m_commandInsertionSlider, m_commandInsertEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeCommandParametersEdit() 
{
	editChanged(this, IDC_COMMAND_PARAMETERS_SLIDER, IDC_COMMAND_PARAMETERS_EDIT, m_commandParametersSlider, m_commandParametersEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeCrossoverEdit() 
{
	editChanged(this, IDC_CROSSOVER_SLIDER, IDC_CROSSOVER_EDIT, m_crossoverSlider, m_crossoverEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeEndInsertEdit() 
{
	editChanged(this, IDC_END_INSERTION_SLIDER, IDC_END_INSERT_EDIT, m_endInsertionSlider, m_endInsertEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeFullyRandomizeEdit() 
{
	editChanged(this, IDC_FULLY_RANDOMIZE_SLIDER, IDC_FULLY_RANDOMIZE_EDIT, m_fullyRandomizeSlider, m_fullyRandomizeEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeMiddleInsertEdit() 
{
	editChanged(this, IDC_MIDDLE_INSERTION_SLIDER, IDC_MIDDLE_INSERT_EDIT, m_middleInsertionSlider, m_middleInsertEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeProgramTypeEdit() 
{
	editChanged(this, IDC_PROGRAM_TYPE_SLIDER, IDC_PROGRAM_TYPE_EDIT, m_programTypeSlider, m_programTypeEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeShapeModeEdit() 
{
	editChanged(this, IDC_SHAPE_MODE_SLIDER, IDC_SHAPE_MODE_EDIT, m_shapeModeSlider, m_shapeModeEdit, 0, 100);
	recalculate();
	
}

/*void GeneticEngineProperties::OnChangeTypeRingEdit() 
{
//	editChanged(this, IDC_TYPE_RING_SLIDER, IDC_TYPE_RING_EDIT, m_typeRingSlider, m_typeRingEdit, 0, 100);
//	recalculate();
	
}*/

void GeneticEngineProperties::OnChangeWideningEdit() 
{
	editChanged(this, IDC_WIDENING_SLIDER, IDC_WIDENING_EDIT, m_wideningSlider, m_wideningEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeZHeightEdit() 
{
	editChanged(this, IDC_Z_HEIGHT_SLIDER, IDC_Z_HEIGHT_EDIT, m_ZHeightSlider, m_ZHeightEdit, 0, 100);
	recalculate();
	
}

void GeneticEngineProperties::OnChangeZStartEdit() 
{
	editChanged(this, IDC_Z_START_SLIDER, IDC_Z_START_EDIT, m_ZStartSlider, m_ZStartEdit, 0, 100);
	recalculate();
	
}

BOOL GeneticEngineProperties::OnKillActive() 
{
	// TODO: Add your specialized code here and/or call the base class

	if (!CPropertyPage::OnKillActive()) return false;

	if (m_copiesOfElitesEdit != theEngine->getEliteCopies()) theEngine->setEliteCopies(m_copiesOfElitesEdit);
	if (m_elitesEdit != theEngine->getElitism()) theEngine->setElitism(m_elitesEdit);
	if (m_tournamentSizeEdit != theEngine->getTournamentSize()) theEngine->setTournamentSize(m_tournamentSizeEdit);
	if (m_populationSizeEdit != theEngine->getPopulationSize()) {
		theEngine->setPopulationSize(m_populationSizeEdit);
	}

	int normalShapeParameter, normalCommandInsert, normalCommandChange, normalCommandDelete, normalCrossover;
	int sum = m_shapeParameterEdit + m_commandInsertEdit + m_commandChangeEdit + m_commandDeleteEdit + m_crossoverEdit;
	if (sum == 0) {
		m_shapeParameterEdit = 20;
		m_commandInsertEdit = 20;
		m_commandChangeEdit = 20;
		m_commandDeleteEdit = 20;
		m_crossoverEdit = 20;
		sum = 100;
	}
	normalShapeParameter = 100.0 * m_shapeParameterEdit / (double)sum;
	normalCommandInsert = 100.0 * m_commandInsertEdit / (double)sum;
	normalCommandChange = 100.0 * m_commandChangeEdit / (double)sum;
	normalCommandDelete = 100.0 * m_commandDeleteEdit / (double)sum;
	normalCrossover = 100 - (normalShapeParameter + normalCommandInsert + normalCommandChange + normalCommandDelete);

	if (normalShapeParameter != theEngine->getParamMutationPercent()) theEngine->setParamMutationPercent(normalShapeParameter);
	if (normalCommandInsert != theEngine->getInsertionMutationPercent()) theEngine->setInsertionMutationPercent(normalCommandInsert);
	if (normalCommandChange != theEngine->getChangeMutationPercent()) theEngine->setChangeMutationPercent(normalCommandChange);
	if (normalCommandDelete != theEngine->getDeletePercent()) theEngine->setDeletePercent(normalCommandDelete);
	if (normalCrossover != theEngine->getCrossoverPercent()) theEngine->setCrossoverPercent(normalCrossover);


	int normalCommandParameter, normalFullyRandomize;
	sum = m_commandParametersEdit + m_fullyRandomizeEdit;
	if (sum == 0) {
		m_commandParametersEdit = 50;
		m_fullyRandomizeEdit = 50;
		sum = 100;
	}
	normalCommandParameter = 100.0 * m_commandParametersEdit / (double)sum;
	normalFullyRandomize = 100 - normalCommandParameter;

	if (normalCommandParameter != theEngine->getParamPercent()) theEngine->setParamPercent(normalCommandParameter);
	if (normalFullyRandomize != theEngine->getCompletePercent()) theEngine->setCompletePercent(normalFullyRandomize);
//	if (normaltypeRingEdit != theEngine->getRingPercent()) theEngine->setRingPercent(normaltypeRingEdit);


	int normalProgramType, normalshapeMode, normalwidening, normalZHeight, normalZStart;
	sum = m_programTypeEdit + m_shapeModeEdit + m_wideningEdit + m_ZHeightEdit + m_ZStartEdit;
	if (sum == 0) {
		m_programTypeEdit = 20;
		m_shapeModeEdit = 20;
		m_wideningEdit = 20;
		m_ZHeightEdit = 20;
		m_ZStartEdit = 20;
		sum = 100;
	}
	normalProgramType = 100.0 * m_programTypeEdit / (double)sum;
	normalshapeMode = 100.0 * m_shapeModeEdit / (double)sum;
	normalwidening = 100.0 * m_wideningEdit / (double)sum;
	normalZHeight = 100.0 * m_ZHeightEdit / (double)sum;
	normalZStart = 100 - (normalProgramType + normalshapeMode + normalwidening + normalZHeight);

	if (normalProgramType != theEngine->getPETypePercent()) theEngine->setPETypePercent(normalProgramType);
	if (normalshapeMode != theEngine->getShapeModePercent()) theEngine->setShapeModePercent(normalshapeMode);
	if (normalwidening != theEngine->getZWideningPercent()) theEngine->setZWideningPercent(normalwidening);
	if (normalZHeight != theEngine->getZHeightPercent()) theEngine->setZHeightPercent(normalZHeight);
	if (normalZStart != theEngine->getZStartPercent()) theEngine->setZStartPercent(normalZStart);

	int normalMiddleInsert, normalEndInsert;
	sum = m_middleInsertEdit + m_endInsertEdit;
	if (sum == 0) {
		m_middleInsertEdit = 50;
		m_endInsertEdit = 50;
		sum = 100;
	}
	normalMiddleInsert = 100.0 * m_middleInsertEdit / (double)sum;
	normalEndInsert = 100 - normalMiddleInsert;

	if (normalMiddleInsert != theEngine->getMiddlePercent()) theEngine->setMiddlePercent(normalMiddleInsert);
	if (normalEndInsert != theEngine->getEndPercent()) theEngine->setEndPercent(normalEndInsert);

	return true;
}

BOOL GeneticEngineProperties::OnSetActive() 
{
	refreshValues();
	return CPropertyPage::OnSetActive();
}
