//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// GeneticUtility.cpp: implementation of the GeneticUtility class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "GeneticUtility.h"
#include "Random.h"
#include <cstdlib>
#include <iostream>

int safeRandom(int max) {
	//Begin DEBUG stuff
	if(max <= 0) { //I cannot think of any place where this would legitimately happen, yet happen it does
		return 0;
	}
	//End DEBUG stuff
	
	double random = Random::genrand();
	
	//Begin DEBUG stuff
	if(random < 0) { //according the the Mersenne Twister documentation, this SHOULD NEVER HAPPEN!
		random = random * (-1.0);
	}
	//End DEBUG stuff
	
	int scaledRand = random * (max + 1);
	if (scaledRand > max) scaledRand--;

	return scaledRand;
}

int randomRange(int min, int max) {
	return safeRandom(max - min) + min;
}
