//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Layer.h: interface for the Layer class.
//
// This class keeps track of all the user defined layers
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LAYER_H__CB28F8AF_F200_11D4_AE3E_00C04FA36E77__INCLUDED_)
#define AFX_LAYER_H__CB28F8AF_F200_11D4_AE3E_00C04FA36E77__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <string>

using namespace std;

class Layer  
{
public:
	Layer();
	virtual ~Layer();
	static Layer* layer;

	void	addLayer(string layer);
	bool	layerExists(const string& layer);
	string	getLayer(int i)	{return _layerNames[i];};
	vector<string>	getLayer()	{return _layerNames;};
	int		numberOfLayers()	{return _layerNames.size();};
	void	bindLayerToZoneType(int i)	{_BoundToZoneType[i]=true;};
	void	bindLayerToZoneType(const string& layer);
	bool	LayerBoundToZoneType(int i)	{return _BoundToZoneType[i];};

protected:
	vector<string>	_layerNames;
	vector<bool>	_BoundToZoneType;

};

#endif // !defined(AFX_LAYER_H__CB28F8AF_F200_11D4_AE3E_00C04FA36E77__INCLUDED_)
