//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// MayaInfo.h: interface for the MayaInfo class.
//
// Maya Info holds all the pertinent information on a Maya object, name, node, and transform
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAYAINFO_H__DF30CC53_388F_11D4_9F86_0000E87A7A07__INCLUDED_)
#define AFX_MAYAINFO_H__DF30CC53_388F_11D4_9F86_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000*/

#include <maya/MGlobal.h>
#include <maya/MDagPath.h>
#include <maya/MFnTransform.h>
#include <string>

using namespace std;

class MayaInfo  
{
public:
	MayaInfo();
	MayaInfo(const string& mayaName);

	virtual ~MayaInfo();

// Accessors
	string& name();
	MDagPath* node();
	MFnTransform* transform();

// Mutators
	bool setName(const string& newName);

private:
	bool makeTransform();
	void clearTransform();

	string				theName;
	MDagPath*           theNode;
	MFnTransform*		theTransform;

};

#endif // !defined(AFX_MAYAINFO_H__DF30CC53_388F_11D4_9F86_0000E87A7A07__INCLUDED_)
