//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Message.cpp: implementation of the Message class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MFCPlugin.h"
#include "Message.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Message::Message()
{
	clear();
}

Message::Message(string messageString) {
	clear();
	content = new string(messageString);
}

Message::Message(int	messageInt) {
	clear();
	content = new int(messageInt);
}

Message::Message(double messageDouble) {
	clear();
	content = new double(messageDouble);
}

Message::Message(stringInt* messageStringInt) {
	clear();
	content = messageStringInt;
}

Message::~Message()
{
	if (content != NULL) delete content;
}

void Message::clear() {
	contentType = "";
	content = NULL;
	to.clear();
}


void Message::addRecipient(AgentID recipient) {
	to.addAgent(recipient);
}


void Message::addRecipientType(string recipientType) {
	to.addAgentType(recipientType);
}

bool Message::isTo(AgentID theAgent) {
	return to.matches(theAgent);
}