//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Opening.h: interface for the Opening class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPENING_H__B350BBA6_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
#define AFX_OPENING_H__B350BBA6_E931_11D3_9F59_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Command.h"

class Opening : public Command  
{
public:
	Opening();
	Opening(const Opening& oldOpening);
	virtual ~Opening();

// Accessors

	double getStart() const {return start;};
	double getWidth() const {return width;};


// Mutators

	void setStart(double newStart) {start = newStart;};
	void setWidth(double newWidth) {width = newWidth;};

// Members Inherited from Command

	virtual CommandType type() const	{return COMMAND_OPENING;};

	virtual std::string print() const;  // Output what the command is for trace purposes

	virtual Command* clone() const { return new Opening(*this); };

	virtual void mutate(); // Mutate the parameters of the opening

	virtual void randomize(); // Randomize the parameters of the opening

	virtual void randomizePERing() {}; // Do nothing; openings do not have PERings

	virtual void run(PrimaryShape* theShape); // Run the command

private:

	double start;
	double width;

};

#endif // !defined(AFX_OPENING_H__B350BBA6_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
