//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// PEType.cpp: implementation of the PEType class.
// Synched with Simon 4/8
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <maya/MGlobal.h>
#include "PEType.h"
#include "Constants.h"
#include "GeneticUtility.h"
#include "ZoneTypes.h"
#include <iostream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PEType::PEType()
{
	theType = 0;
}

PEType::PEType(const PEType& oldPEType) {
	theType = oldPEType.theType;
}

PEType::PEType(int newPEType) {
	if(newPEType >= 0 && newPEType < ZoneTypes::zoneTypes->getNumZoneTypes()) {
		theType = newPEType;
	}
	else {
		theType = 0;
	}
}

PEType::~PEType()
{

}

void PEType::mutate() {
	if(!ZoneTypes::zoneTypes->getMutableZoneType(getType()))	{
		do{
			theType = randomRange(0, ZoneTypes::zoneTypes->getNumZoneTypes() - 1);
		}
		while(ZoneTypes::zoneTypes->getMutableZoneType(getType()));
	}
}

const PEType& PEType::operator=(const PEType& oldPEType) {
	theType = oldPEType.theType;
	return oldPEType;
}