//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
#if !defined(AFX_POPULATIONPROPERTIES_H__85BCF233_3657_11D4_9F85_0000E87A7A07__INCLUDED_)
#define AFX_POPULATIONPROPERTIES_H__85BCF233_3657_11D4_9F85_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PopulationProperties.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// PopulationProperties dialog


#include <list>
#include "GeneticEngine.h"
#include "Resource.h"
#include "Settable.h"

class PopulationProperties : public CPropertyPage, public Settable
{
	DECLARE_DYNCREATE(PopulationProperties)

// Construction
public:
	PopulationProperties();
	~PopulationProperties();

// Dialog Data
	//{{AFX_DATA(PopulationProperties)
	enum { IDD = IDD_DIALOG2 };
	int		m_nGenerations;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(PopulationProperties)
	public:
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	void	setEngine(GeneticEngine* newEngine);
	static	Design*	getCurrentDesign();
	void	newTask(string taskName, int length);
	void	step(int steps = 1);
	void	taskFinished();
	bool	taskUnderway();
	void    changeCurrent(int newCurrent);
	static GeneticEngine*	theEngine;
	static int	currentDesign;

	void	updateDialogText();  // Update the text in the dialog
	void	updateBreedingText();  // Update the text in the breeding statistics box
	void	interpret();
	bool	isInitialized()	{return _initialized;};


public:
	// Generated message map functions
	//{{AFX_MSG(PopulationProperties)
	virtual BOOL OnInitDialog();
	afx_msg void OnDeltaposShiftIndividual(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelendokSelectIndividual();
	afx_msg void OnStartgp();
	afx_msg void OnRunNGenerations();
	afx_msg void OnModifyIndividualButton();
	afx_msg void OnSaveIndividual();
	afx_msg void OnSavePopulation();
	//}}AFX_MSG
	afx_msg LRESULT OnUpdateMess( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()

private:
	//void	updateDialogText();  // Update the text in the dialog
	//void	updateBreedingText();  // Update the text in the breeding statistics box
	//void	interpret();

	//static GeneticEngine*				theEngine;

	//static int							currentDesign;
	int							oldPopSize; // To test whether the population has changed size on re-entry
	bool	_initialized;
	bool	_taskUnderway;

//	std::vector<PrimaryShape*>	primaries;
	std::list<string>			loftShapeList;
public:
	void reInterpret(bool entirePop);
	static PopulationProperties*		thePopPropsPage;
	
// Settables inheritance
protected:

	virtual void reportSettings();
	virtual void receiveSettings();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_POPULATIONPROPERTIES_H__85BCF233_3657_11D4_9F85_0000E87A7A07__INCLUDED_)
