//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Reflection.h: interface for the Reflection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REFLECTION_H__B350BBA4_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
#define AFX_REFLECTION_H__B350BBA4_E931_11D3_9F59_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Transformation.h"

typedef enum{ X_REFLECTION = 0, Y_REFLECTION, BOTH_REFLECTION } Reflect;

class Reflection : public Transformation  
{
public:
	Reflection();
	Reflection(const Reflection& oldReflection);
	virtual ~Reflection();

// Accessors

	Reflect getAxes() const {return axes;};

// Mutators

	void setAxes(Reflect newAxes) {axes = newAxes;};

// Members Inherited from Command

	virtual CommandType type() const	{return COMMAND_REFLECT;};

	virtual std::string print() const;  // Output what the command is for trace purposes

	virtual Command* clone() const { return new Reflection(*this); };

	virtual void mutate(); // Mutate the parameter of the Reflection

	virtual void randomize(); // Randomize the parameters of the Reflection

	virtual void run(PrimaryShape* theShape); // Run the command

private:

	Reflect axes;

};

#endif // !defined(AFX_REFLECTION_H__B350BBA4_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
