//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Representation.h: interface for the Representation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REPRESENTATION_H__44214126_3A7D_11D4_9F88_0000E87A7A07__INCLUDED_)
#define AFX_REPRESENTATION_H__44214126_3A7D_11D4_9F88_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Analysis.h"
#include <string>

using namespace std;

class Representation  
{
public:
	Representation();
	virtual ~Representation();

	virtual Analysis*	getAnalysis(const string& name) = 0;		// Get analysis of name "name"

private:
	virtual void instantiateAnalyses() = 0;	// This is the function that must instantiate ALL analyses that run on this representation
										// a representation subclass ought to define a static list of all representations.
										// This function must be run ONCE only for each subclass of Representation, and it must occur before any Agents are instantiated

};

#endif // !defined(AFX_REPRESENTATION_H__44214126_3A7D_11D4_9F88_0000E87A7A07__INCLUDED_)
