//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Scale.h: interface for the Scale class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCALE_H__B350BBA3_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
#define AFX_SCALE_H__B350BBA3_E931_11D3_9F59_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Transformation.h"

class Scale : public Transformation  
{
public:
	Scale();
	Scale(const Scale& oldScale);
	virtual ~Scale();

// Accessors

	double getX() const {return x;};
	double getY() const {return y;};
	double getZ() const {return z;};

	static double getMinXScale() {return minXScale;};
	static double getMaxXScale() {return maxXScale;};
	static double getMinYScale() {return minYScale;};
	static double getMaxYScale() {return maxYScale;};
	static double getMinZScale() {return minZScale;};
	static double getMaxZScale() {return maxZScale;};

// Mutators

	void setX(double newX) {x = newX;};
	void setY(double newY) {y = newY;};
	void setZ(double newZ) {z = newZ;};

	static void setMinXScale(double newMinXScale) {minXScale = newMinXScale;};
	static void setMaxXScale(double newMaxXScale) {maxXScale = newMaxXScale;};
	static void setMinYScale(double newMinYScale) {minYScale = newMinYScale;};
	static void setMaxYScale(double newMaxYScale) {maxYScale = newMaxYScale;};
	static void setMinZScale(double newMinZScale) {minZScale = newMinZScale;};
	static void setMaxZScale(double newMaxZScale) {maxZScale = newMaxZScale;};

// Members Inherited from Command

	virtual CommandType type() const	{return COMMAND_SCALE;};

	virtual std::string print() const;  // Output what the command is for trace purposes

	virtual Command* clone() const { return new Scale(*this); };

	virtual void mutate(); // Mutate the parameters of the scale

	virtual void randomize(); // Randomize parameters and PERing

	virtual void run(PrimaryShape* theShape); // Run the command
private:

	double x, y, z;

	static double minXScale;
	static double maxXScale;
	static double minYScale;
	static double maxYScale;
	static double minZScale;
	static double maxZScale;
};


#endif // !defined(AFX_SCALE_H__B350BBA3_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
