// Settings.h: interface for the Settings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGS_H__5CA1E390_667E_11D4_9FB1_0000E87A7A07__INCLUDED_)
#define AFX_SETTINGS_H__5CA1E390_667E_11D4_9FB1_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include <list>
using namespace std;

// Settings Constants
const string DEFAULT_SETTINGS_FILE = "\\bin\\plug-ins\\agencyDefaults.agc";

typedef struct {
	string category;
	string type;
	string name;
	int    index;
	int	   index2;
	int    iValue;
	double dValue;
	string sValue;
} Setting;

class Settings  
{
public:
	Settings();
	virtual ~Settings();

	static string getSettingType(const string& category, const string& settingName, int index = 0, int index2 = 0);
	static string getStringSetting(const string& category, const string& settingName, int index = 0, int index2 = 0);
	static int    getIntSetting(const string& category, const string& settingName, int index = 0, int index2 = 0);
	static double getDoubleSetting(const string& category, const string& settingName, int index = 0, int index2 = 0);

	static bool getSetting(const string& category, const string& settingName, string& value, int index = 0, int index2 = 0);
	static bool getSetting(const string& category, const string& settingName, int& value, int index = 0, int index2 = 0);
	static bool getSetting(const string& category, const string& settingName, double& value, int index = 0, int index2 = 0);

	static bool setSetting(const string& category, const string& settingName, const string& setting, int index = 0, int index2 = 0);
	static bool setSetting(const string& category, const string& settingName, int setting, int index = 0, int index2 = 0);
	static bool setSetting(const string& category, const string& settingName, double setting, int index = 0, int index2 = 0);

	static void addSetting(const string& category, const string& settingName, const string& type, int index = 0, int index2 = 0);
	static void removeSetting(const string& category, const string& settingName, int index = 0, int index2 = 0);

	static int	 numberOf(const string& category, const string& settingName);

	static Settings* settings;

	static void clearSettings();
	static void readSettings();
	static void writeSettings();
	static void setSettings(list<Setting*>& newSettings);
	static void setDefaultFile();

	static void gatherSettings();
	static void disseminateSettings();

	static void setSettingsFile(string settingsFile) {_settingsFile = settingsFile;};
	static string getSettingsFile() {return _settingsFile;};
	void locateSettingsFile();

private:
	static string _settingsFile;
	static list<Setting*> _settings;
	static string	decodeString(const string& inString);
	static string	encodeString(const string& inString);

};

#endif // !defined(AFX_SETTINGS_H__5CA1E390_667E_11D4_9FB1_0000E87A7A07__INCLUDED_)
