//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// ShapePair.h: interface for the ShapePair class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHAPEPAIR_H__9298BD21_4789_11D4_9F8F_0000E87A7A07__INCLUDED_)
#define AFX_SHAPEPAIR_H__9298BD21_4789_11D4_9F8F_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Shape;

class ShapePair  
{
public:
	ShapePair(Shape* newA = NULL, Shape* newB = NULL) {_A = newA; _B = newB;};
//	ShapePair();
	ShapePair(const ShapePair& oldPair);
	virtual ~ShapePair();
	
	void	A(Shape* newA) {_A = newA;};
	void	B(Shape* newB) {_B = newB;};
	void	set(Shape* newA, Shape* newB) {_A = newA; _B = newB;};

	Shape*	A() {return _A;};
	Shape*	B() {return _B;};

	bool	contains(Shape* C) {return ((_A == C) || (_B == C));};
	bool	replace(Shape* oldShape, Shape* newShape);

	const	ShapePair& operator=(const ShapePair &rhs) {_A = rhs._A; _B = rhs._B; return *this;};
	bool	operator==(const ShapePair &rhs);

private:
	Shape*	_A;
	Shape*  _B;
};

#endif // !defined(AFX_SHAPEPAIR_H__9298BD21_4789_11D4_9F8F_0000E87A7A07__INCLUDED_)
