//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Transformation.cpp: implementation of the Transformation class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <maya/MGlobal.h>
#include "Transformation.h"
#include "GeneticUtility.h"
#include "Constants.h"
#include "ZoneTypes.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Transformation::Transformation()
{
	PERing = new std::list<PEType*>();
}

Transformation::Transformation(const Transformation& oldTransformation) {
	
	PERing = new std::list<PEType*>();
	for(std::list<PEType*>::const_iterator position = oldTransformation.getPERing()->begin(); position != oldTransformation.getPERing()->end(); position++) {
		PERing->push_back(new PEType(*(*position)));
	}
	
}

Transformation::~Transformation()
{

	while (PERing->size() > 0) {
		delete (*PERing->begin());
		PERing->pop_front();
	}

	delete PERing;

}

void Transformation::randomizePERing() {

	int numTypes = randomRange(PERING_MIN, PERING_MAX);
	
	std::list<PEType*>* newRing = new std::list<PEType*>();
	for (int i = 0; i < numTypes; i++)
		newRing->push_back(new PEType(randomRange(0, ZoneTypes::zoneTypes->getNumZoneTypes())));

	setPERing(newRing);
}


void Transformation::setPERing(std::list<PEType*>* newRing) {
	
	while (PERing->size() > 0) {
		delete (*PERing->begin());
		PERing->pop_front();
	}

	delete PERing;

	PERing = newRing;
}