//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Transformation.h: interface for the Transformation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRANSFORMATION_H__B350BBA1_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
#define AFX_TRANSFORMATION_H__B350BBA1_E931_11D3_9F59_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Command.h"
#include <list>
#include "PEType.h"

class Transformation : public Command
{
public:
	Transformation();
	Transformation(const Transformation& oldTransformation);
	virtual ~Transformation();

// Accessors
	
	const std::list<PEType*>* getPERing() const {return PERing;};

	//virtual Command& clone() const { return *(new Transformation(*this)); };

// Mutators

	void setPERing(std::list<PEType*>* newRing); //do not rely upon member based copying - the PERing provided must not be destroyed
	//the above command effectively makes a new PERing based upon the provided PERing - the template PERing can safely be deleted after the copy operation

	virtual void randomizePERing();  // Set PERing to random length and random values

private:
	
	std::list<PEType*> *PERing;  // Must delete



};

#endif // !defined(AFX_TRANSFORMATION_H__B350BBA1_E931_11D3_9F59_0000E87A7A07__INCLUDED_)

