//
// Copyright (C) 2001 Simon Greenwold. You are allowed to use or modify the code, but this note must be kept intact.
// 
// Translation.h: interface for the Translation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRANSLATION_H__B350BBA2_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
#define AFX_TRANSLATION_H__B350BBA2_E931_11D3_9F59_0000E87A7A07__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Transformation.h"

class Translation : public Transformation  
{
public:
	Translation();
	Translation(const Translation& oldTranslation);
	virtual ~Translation();

// Accessors

	double getX() const {return x;};
	double getY() const {return y;};
	double getZ() const {return z;};

	static double getMinXTranslation() {return minXTranslation;};
	static double getMaxXTranslation() {return maxXTranslation;};
	static double getMinYTranslation() {return minYTranslation;};
	static double getMaxYTranslation() {return maxYTranslation;};
	static double getMinZTranslation() {return minZTranslation;};
	static double getMaxZTranslation() {return maxZTranslation;};

// Mutators

	void setX(double newX) {x = newX;};
	void setY(double newY) {y = newY;};
	void setZ(double newZ) {z = newZ;};

	static void setMinXTranslation(double newMinXTranslation) {minXTranslation = newMinXTranslation;};
	static void setMaxXTranslation(double newMaxXTranslation) {maxXTranslation = newMaxXTranslation;};
	static void setMinYTranslation(double newMinYTranslation) {minYTranslation = newMinYTranslation;};
	static void setMaxYTranslation(double newMaxYTranslation) {maxYTranslation = newMaxYTranslation;};
	static void setMinZTranslation(double newMinZTranslation) {minZTranslation = newMinZTranslation;};
	static void setMaxZTranslation(double newMaxZTranslation) {maxZTranslation = newMaxZTranslation;};

// Members Inherited from Command

	virtual CommandType type() const	{return COMMAND_TRANSLATE;};

	virtual std::string print() const;  // Output what the command is for trace purposes

	virtual Command* clone() const { return new Translation(*this); };

	virtual void mutate(); // Mutate the parameters of the translation

	virtual void randomize();

	virtual void run(PrimaryShape* theShape); // Run the command
private:

	double x, y, z;

	static double minXTranslation;
	static double maxXTranslation;
	static double minYTranslation;
	static double maxYTranslation;
	static double minZTranslation;
	static double maxZTranslation;
};

#endif // !defined(AFX_TRANSLATION_H__B350BBA2_E931_11D3_9F59_0000E87A7A07__INCLUDED_)
